/*******************************************************************************
 Copyright 1989,1990 David Pomerantz  
 
 This is the C code that appeared in the article "A Few Good Colors" 
 (Computer Language, August 1990).  This code was written to illustrate
 the article and has never been compiled.

 The 68000 assembler code that appears in a companion file is the
 actual code that I wrote for Digital Vision Inc.'s ComputerEyes/Pro 
 video digitizer.  That stuff works (it had better, several hundred
 copies have been shipped to customers).

 If you have questions, I can be reached at: 

 Micro Alliance, Inc.		Phone: (617) 245-8879
 107 Greenwood Street		AppleLink: D6543
 Wakefield, MA  01880		Certified Apple Developer
*****************************************************************************/

/* Listing 1. Converting to 15-bit Pixels */

#define MAXCOLORS 	32768        /* 215 colors */
#define IMAGESIZE	(640 * 480)

typedef unsigned char byte;

typedef struct {
	byte	red;
st = malloc(sizeof(short) * MAXCOLORS);

currentSize = 0;
for (15bitColor=0; 15bitColor < MAXCOLORS; ++15bitColor)
	{
	if (histogram[15bitColor] != 0)
		colorList[currentSize++] = 15bitColor;
	}

colorList = realloc(colorList,currentSize);


/* Listing 3. The colorRect structure */

typedef struct {				
	long	first, last;		/* indexes into colorList		*/
	long	histSum;			/* total color count for region	*/
	
	byte	redMin,redMax;		/* min's and max's				*/
	byte	greenMin,greenMax;	/* for the color components		*/
	byte	blueMin,blueMax;	/*   define the region			*/

	byte	widestColor;		/* color with the widest range	*/
	byte	red,green,blue;		/* our eventual palette color	*/
	} colorRect;



/* Listing 6. Calculating the Colors */

/* These macros split a 15-bit color into it's */
/*   three 5-bit color components              */
#define RED(x) 		(((x) & 0x7C00) >> 10)
#define GREEN(x) 	(((x) & 0x03E0) >> 5)
#define BLUE(x) 	((x) & 0x001F)

calcColor(colorRect *cr)
	{
	short 	15bitColor;
	byte	red, green, blue;

	red = green = blue = 0;
	for (i = cr->first; i < cr->last; ++i)
		{
		15bitColor = colorList[i];
		red   += RED(15bitColor) * histogram[15bitColor];
		green += GREEN(15bitColor) * histogram[15bitColor];
		blue  += BLUE(15bitColor) * histogram[15bitColor];
		}
	red /= cr->histSum;
	green /= cr->histSum;
	blue /= cr->histSum;
	}



/* Listing 7. Building the Palette Lookup Table */

bldLookup(colorRect *cr, byte paletteIndex)
	{
	byte	red, green, blue;
	short	15bitColor;

	for (red = cr->redMin; red <= cr->redMax; ++red)
		{
		for (green = cr->greenMin; green <= cr->greenMax; 
				++green)
			{
			for (blue = cr->blueMin; blue <= cr->blueMax;
					++blue)
				{
				15bitColor = red << 10 | green << 5 | blue;
				lookup[15bitColor] = paletteIndex;
				}
			}
		}
	}


